//*************************************************************************************
// 	: SQ7617_I2C1.c
// 汾		: V1.1 (Sep. 3, 20)
// 		: I2C1 ʹú (I2C1Ƴ)
// ע		: I2C1 غ㼯ڱӳ
//**************************************************************************************
#include "main.h"

unsigned char errCode = 0x00;
unsigned char tWait = 0;
unsigned char addrDirection;
//*********************************************************************
// 	: I2C1_SetSlaveAddr()
// 	: ôģʽַ
// ֵ	: none
// شֵ	: none
//
// ע		: 
//*********************************************************************
void I2C1_SetSlaveAddr(uchar addr){
	I2C1AR = addr & 0xfe;				// SA0[7:1]: Slave address setting
										// 0Xfe	1111 1110		
										// &0xfe   : and clear bit0  
}



//*********************************************************************
// 	: I2C1_Init()
// 	: I2C1ʼ
// ֵ	: none
// شֵ	: none
//
// ע		: I2C1 ùܽšģʽKI2C
//*********************************************************************
void I2C1_Init(){

  //====== I2C1ܽųʼ ======
  /*
	//--SDA1 (P0.0) ; SCL1 (P0.2)-------
	    FSELR0 = (FSELR0&0xF0)|0x03;         // 趨ѡĴ0    
        PCSELR1_I2C1 = 0x00;				 // 趨ΧͨѡĴ
        
        P0FC_P0_SDA1;                        // P0.0趨ΪSDA1
        P0FC_P2_SCL1;                        // P0.2趨ΪSCL1

        while(P0DI_P0!=1 || P0DI_P2 !=1)     // ȷϴ߽ӿڽλSDASCLΪߵλ
		{    
			CLR_WDT;						 // Źʱ (ι)
			errCode = initBusLowErr;
			I2C1_Error_Handling();           // 
		}    
        SBI1CR2_SBIM = 1;                    // ѡΪ߽ӿģʽ

  */


  /*
    //--SDA1 (P2.1) ; SCL1 (P2.2)-------  
        FSELR2 = (FSELR2&0xF0)|0x00;		 // 趨ѡĴ2
        PCSELR1_I2C1 = 0x01;				 // 趨ΧͨѡĴ

        P2FC_P1_SDA1;                        // P2.1趨ΪSDA1
        P2FC_P2_SCL1;                        // P2.2趨ΪSCL1
        
        while(P2DI_P1!=1 || P2DI_P2 !=1)     // ȷϴ߽ӿڽλSDASCLΪߵλ
		{  
			CLR_WDT;						 // Źʱ (ι)
			errCode = initBusLowErr;
			I2C1_Error_Handling();           // 
		}    
        SBI1CR2_SBIM = 1;                    // ѡΪ߽ӿģʽ
      
  */


	//--SDA1 (P4.6) ; SCL1 (P4.7)-------    [ѡܽ]
 	FSELR4 = (FSELR4&0x0F)|0x30;             // 趨ѡĴ4
	PCSELR1_I2C1 = 0x02;				     // 趨ΧͨѡĴ
	
    P4FC_P6_SDA1;                            // P4.6趨ΪSDA1
    P4FC_P7_SCL1;                            // P4.7趨ΪSCL1

    while(P4DI_P6!=1 || P4DI_P7 !=1)         // ȷϴ߽ӿڽλSDASCLΪߵλ
    {  
		CLR_WDT;						     // Źʱ (ι)
		errCode = initBusLowErr;
		I2C1_Error_Handling();               // 
	}    
    SBI1CR2_SBIM = 1;                        // ѡΪ߽ӿģʽ


  //====== ܿ(Enoneble) ======
      PCKEN2_I2C1 = 1;                       // ȿݴò,I2C1 Enable

  //====== 趨 ======
    //SBI1CR1 = 0x16;

      SBI1CR1_ACK = 1;                       // Ӧģʽ(ACK enable)
      SBI1CR1_BC  = BC_8bit;                    // (λ)9bit = 8bit + 1bit(ACK)
      SBI1CR1_SCK = SCK_HI_135_LO_138;       // ģʽƵʿ @fsysclk=24MHzfsclԼΪ88 kHz

   	// SBI1CR2<MST> <TRX><BB>Ϊ0, <PIN>Ϊ1,<SWRST>Ϊ00,ڴģʽжĬֵ
	SBI1CR2 = 0x18;						// 0001 1000
	
}



//SBI1CR2---------------------------------------------------------------   	
//-----bit7 | bit6 | bit5 | bit4  |  bit3  | bit2 | bit1~bit0
//---  <MST>, <TRX>, <BB>, <PIN> and <SBIM>  <none>   <SWRST>   ---------
//---  <MST>   1 : Master
//             0 : Slave
//---  <TRX>   1 :    ; 0: 
//---  <BB>    1 : ʼ
//             0 : ֹͣ
//---  <PIN>   1 : ȡжϷ
//
//---  <SBIM>  1 : Serial bus interface mode(ģʽ) / 0:Port mode
//---  <SWRST> ÿʼλ  
//----------------------------------------------------------------------  



//*********************************************************************
// 	: I2C1_Int()
// 	: /ֹ I2C1ж
// ֵ	: - config : enable  I2C1ж
//                     : disable ֹI2C1ж
// شֵ	: none
//
// ע		: ִкῪж(IMF)**
//*********************************************************************
void I2C1_Int(uchar config){
	__asm("DI");						// ֹпж
    
	IFR_I2C1 = 0;                       // ж
	IER_I2C1 = config;	                // config = enable  ,I2C1ж
                                        // config = disable ,I2C1жϽֹ

	__asm("EI");						// пж
}


//*********************************************************************
// 	: I2C1_Start()
// 	: ʼ
// ֵ	: - deviceId : 趨 Slave Device ID (Slave addr)
//                          e.g. AT24C08Ϊ(0xa0)
//            - addr      : ʼд/(ȡ)Slaveʼλַ
// شֵ	: errCode
//
// ע		: 
//*********************************************************************
uchar I2C1_Start(uchar deviceId, uchar addr){
	while(SBI1SR_BB){                   // ȷ״̬Ϊ״̬ 0: free ; 1 :busy
    }

    SBI1CR1_ACK = 1;                    // *** SBI1CR1<ACK>趨,ڴ֮ǰ ***   
	
	I2C1_SetSlaveAddr_Direction(deviceId, directionW); // ôװõַ뷽
	
	SBI1CR2 = 0xf8;						// Write "1" to SBI0CR2<MST>, <TRX>, <BB>, <PIN>  and <SBIM>to "1"
										// 1111 1000
										// Set master,,ʼ,ȡжϷ and ģʽ
	    
 	I2C1_Confirm_Tx_Completed();        // ȴbyteɣȷPINǷΪ0
	I2C1_Wait_Slave_ACK();              // ȴSlaveشACK

    NOP;

    //---------------------------------------------------------------------------------------------

	if(errCode != 0)  return errCode;
  
	SBI1DBR = addr;					    // 趨Ҫʼдʼλַ
	SBI1CR2 = 0xf8;						// Write "1" to SBI0CR2<MST>, <TRX>, <BB>, <PIN>  and <SBIM>to "1"
										// 1111 1000
                                        
    I2C1_Confirm_Tx_Completed();        // ȴbyteɣȷPINǷΪ0
    I2C1_Wait_Slave_ACK();              // ȴSlaveشACK

    NOP;
}


//*********************************************************************
// 	: I2C1_Confirm_Tx_Completed()
// 	: ȴbyteɣȷPINǷΪ0
// ֵ	: none
// شֵ	: none
// 
// ע		:
//*********************************************************************
void I2C1_Confirm_Tx_Completed(){
   	while(SBI1SR_PIN)                   // ȴbyte, PINΪ0	
	{
    }			                         
  

}


//*********************************************************************
// 	: I2C1_Wait_Slave_ACK()
// 	: ȴSlaveشACK
// ֵ	: none
// شֵ	: - errCode
//
// ע		:
//*********************************************************************
uchar I2C1_Wait_Slave_ACK(){
    uchar tWait;
    errCode = 0x00;
	tWait = 0;

    while(SBI1SR_LRB == 1){			    // check <LRB> յλ, ӻӦźACK								
            tWait++;					    // Ӧ,  ==> SCKᱣ
                
            if(tWait>waitCountMax){	        // Ӧѭ		
                I2C1_Stop();			    // I2C1 stop -> release SCK
				errCode = nackTimeoutErr;
 				break;
            }
	NOP;
    }
	
	NOP;
	if(errCode != 0)  return errCode;
	
    // ACK
    errCode = 0x00;                    // error, errorCode = 0x00
    return errCode;
 
}


//*********************************************************************
// 	: I2C1_SetSlaveAddr_Direction() 
// 	: ôװõַ뷽
// ֵ	: - deviceId     : 趨 Slave Device ID (Slave addr)
//            - i2cDirection :  directionW (ҪдݵSlave)
//                              directionR (ҪSlave)
// شֵ	: errCode
//
// ע		: 
//*********************************************************************
void I2C1_SetSlaveAddr_Direction(uchar deviceId, uchar i2cDirection){

    addrDirection = (deviceId | i2cDirection);
	SBI1DBR = addrDirection;

}




//*********************************************************************
// 	: I2C1_ReStart()
// 	: I2C1 ReStart
// ֵ	: none
// شֵ	: none
//
// ע		: һڱװװüݴ䷽
//            Master modeʹ
//*********************************************************************
uchar I2C1_ReStart(uchar deviceId){

	SBI1CR2 = 0x18;						// 0001 1000
										// Set master,,ʼ,ȡжϷ and ģʽ

	while(SBI1SR_BB){                   // ȷ״̬Ϊ״̬ 0: free ; 1 :busy
    }	  
	while(SBI1SR_LRB == 0){}
    
    I2C1_SetSlaveAddr_Direction(deviceId, directionR); // ôװõַ뷽
	SBI1CR2 = 0xf8;						// Write "1" to SBI1CR2<MST>, <TRX>, <BB>, <PIN>  and <SBIM>to "1"
										// 1111 1000
                                        
    I2C1_Confirm_Tx_Completed();        // ȴbyteɣȷPINǷΪ0
    I2C1_Wait_Slave_ACK();              // ȴSlaveشACK
    return errCode;
}



//*********************************************************************
// 	: I2C1_Stop()
// 	: ֹͣ
// ֵ	: none
// شֵ	: none
//
// ע		: 
//            Master modeʹ
//*********************************************************************
void I2C1_Stop(void){
	SBI1CR2 = 0xd8;						// Set SBI1CR2<MST>, <TRX> and <PIN> to "1" and SBI0CR2<BB> to "0"
										// 1101 1000
										// Set master,,ֹͣ,ȡжϷ and Portģʽ
										
	while(SBI1SR_BB == 1){}			    // ȷ״̬Ϊ״̬ 0: free ; 1 :busy
}





//*********************************************************************
// 	: I2C1_Bytes_Write() 
// 	: д(byte write * len)
// ֵ	: 
//            - *data   :д
//            - len     :дϳ
// شֵ	: errCode
//
// ע		:  
//            Master modeʹ
//*********************************************************************
uchar I2C1_Bytes_Write(uchar *data, uchar len){
uchar i;

	if(errCode != 0)  return errCode;
 
	for(i=0; i<len; i++){	
		tWait = 0;
		SBI1DBR = *data;
		data++;
        
        I2C1_Confirm_Tx_Completed();     // ȴbyteɣȷPINǷΪ0
        I2C1_Wait_Slave_ACK();	         // ȴSlaveشACK
	}
    return errCode;
}


//*********************************************************************
// 	: I2C1_Bytes_Read()
// 	: նȡ (byte read * len)
// ֵ	: - addr    :ʼȡʼλַ
//            - *data   :ȡ
//            - len     :ȡϳ
// شֵ	: errCode
//
// ע		:  
//            Master modeʹ
//*********************************************************************
uchar I2C1_Bytes_Read(uchar *data, uchar len){
	uchar i;
    if(I2C1_Wait_Slave_ACK()!= 0x00){
       return errCode;

    }
    
	NOP;

	len -= 1;
    // (len-1)byte..................
	for(i=0; i<len; i++){
		SBI1DBR   = 0x00;				// write dummy data to set PIN = 1
		I2C1_Confirm_Tx_Completed();
		*data = SBI1DBR;
		data++;
	}

    // һbyte..................
	SBI1CR1_ACK = 0;					// ACK=0
	SBI1DBR     = 0x00;					// write dummy data to set PIN = 1
    I2C1_Confirm_Tx_Completed();
	*data = SBI1DBR;

    //	Terminonetion of data transfer by master mode
    //	Sent 1 bit negative acknowledge............
	SBI1CR1_BC = 1;						// BC, bit count = 1
	SBI1DBR    = 0x00;					// write dummy data to set PIN = 1
	I2C1_Confirm_Tx_Completed();
}



//*********************************************************************
// 	: I2C1_Reset()
// 	: λ
// ֵ	: none
// شֵ	: none
// 
// ע		: SBI1CR1,I2C1AR,SBI1CR2 ,SBI1CR2<SBIM>
//*********************************************************************
void I2C1_Reset(){
	SBI1CR2 = 0x1A;						// дSWRST[1:0] = 0x02
	SBI1CR2 = 0x19;						// дSWRST[1:0] = 0x01

}


//*********************************************************************
//    : IntI2C1()
//  : I2C1жϳ
// ע     :
//*********************************************************************
void __interrupt IntI2C1(void){
  __asm("NOP");                         // ָ

}



//*********************************************************************
// 	: I2C1_Error_Handling() 
// 	: 
// ֵ	: none
// شֵ	: none
// 
// ע		: I2C1ʼʱ߽ӿڽλSDASCLûнΪߵλ
//            
//*********************************************************************
void I2C1_Error_Handling(){
	if (errCode == initBusLowErr){
	
	//Add your error handling ......
		while(1){
			CLR_WDT;					 // Źʱ (ι)
			__asm("NOP");
		}
    }

}






